'use strict';

let Process;

const Connections = new Map();

module.exports = class Connection
{
  constructor( type, id )
  {
    if( !Process )
    {
      Process = require( '../process.child' );
    }

    Process.trigger({ event: 'connected', connection: { type, id } });

    let connections = Connections.get( type );

    if( !connections )
    {
      Connections.set( connections = new Map() );
    }

    connections.set( id, this );
  }

  destroy()
  {
    let connections = Connections.get( type );

    if( connections )
    {
      if( connections.get( id ) === this )
      {
        connections.delete( id );

        Process.trigger({ event: 'disconnected', connection: { type, id } });
      }
    }
  }

  static get( type, id )
  {
    //return
  }

  // send :message reliable (true/false)
}
